#include <Pokitto.h>
#include <miloslav.h>
#include "SDFRenderer.h"
#include "SDFBitmap.h"
#include "track_sdf.h"

using Pokitto::Buttons;
using Pokitto::Core;
using Pokitto::Display;

std::int32_t _camera_x = -110;
std::int32_t _camera_y = -88;

SDFBitmap sdf_bmp;

void init() {
    // Use 41x41 track_sdf bitmap as distance field scaled to 640x640
    SDFRenderer<std::int8_t>::get_instance().set_distance_bitmap(track_sdf, 41, 41, 640, 640);
    sdf_bmp.set_distance_bitmap(track_sdf, 41, 41, 640, 640);
    
    // Replace TAS::BGTileFiller with SDFRenderer
    Pokitto::Display::lineFillers[0] = SDFRenderer<std::int8_t>::line_filler;
    
    Pokitto::Display::loadRGBPalette(miloslav);
}

void update() {
    // Print FPS counter
    Display::setFont(fontTiny);
    Display::color = Core::fps_counter_updated ? 7 : 5;  // Use brighter white every time the counter value is updated
    Display::print(1, 1, Core::fps_counter); Display::print("\n");
    
    // Reset fps_counter_updated flag
    Core::fps_counter_updated = false;
    
    // Read the value of the distance field at the center of the screen
    // std::int32_t dist = sdf_bmp.get_distance(110 + _camera_x, 88 + _camera_y);
    // Display::color = 5;
    // Display::print(1, 166, "Distance: "); Display::print(dist); Display::print("\n");
    
    // Move camera
    _camera_x += 3 * (Buttons::rightBtn() - Buttons::leftBtn());
    _camera_y += 3 * (Buttons::downBtn() - Buttons::upBtn());
    
    // Use camera coordinates to move the distance field
    SDFRenderer<std::int8_t>::get_instance().shift_distance_field(-_camera_x, -_camera_y);
}
